package com.yaohun.farmingwar.listener;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import org.bukkit.GameMode;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.scheduler.BukkitRunnable;

public class JoinListener implements Listener {

    private FarmingWar farmingWar;
    private Game game;
    public JoinListener(FarmingWar farmingWarMainClass){
        farmingWar = farmingWarMainClass;
        game = FarmingWar.getGame();
    }

    @EventHandler
    public void onJoin(PlayerJoinEvent e){
        new BukkitRunnable() {
            @Override
            public void run() {
                if(!game.isStarted()) {
                    game.start();
                }
                game.initPlayerData(e.getPlayer());
            }
        }.runTaskLater(farmingWar,10L);
    }
}
